﻿/*------------------------------------------------------------------
Copyright (c) 2008 visualSingularity.net. All rights reserved.

This file is part of Hyperbolic control.

Hyperbolic control is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

Hyperbolic control is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
------------------------------------------------------------------*/

using System;
using System.Collections.Generic;
using System.Text;
using Hyperbolic.Vectors;

namespace Hyperbolic.Model
{
    public interface ITreeModel
    {

        /// <summary> Gets the root of the tree model.
        /// </summary>
        NodeModel RootNodeModel { get; }

        /// <summary> Gets the distance between a node and its children in the hyperbolic space.
        /// </summary>
        double Length { get; }

        ScreenVector ContainerOrigin { get; set; }
        ScreenVector ContainerBounds { get; set; }
        

    }
}
